Index: palm/trunk/SOURCE/land_surface_model.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model.f90	(revision 1539)
+++ palm/trunk/SOURCE/land_surface_model.f90	(revision 1551)
@@ -412,7 +486,92 @@
     END INTERFACE lsm_soil_model
 
+    INTERFACE lsm_swap_timelevel
+       MODULE PROCEDURE lsm_swap_timelevel
+    END INTERFACE lsm_swap_timelevel
 
  CONTAINS
 
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!-- Allocate land surface model arrays and define pointers
+!------------------------------------------------------------------------------!
+    SUBROUTINE init_lsm_arrays
+    
+
+       IMPLICIT NONE
+
+!
+!--    Allocate surface and soil temperature / humidity
+#if defined( __nopointer )
+       ALLOCATE ( m_liq_eb(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( m_liq_eb_p(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( m_soil(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( m_soil_p(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( t_surface(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( t_surface_p(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( t_soil(nzb_soil:nzt_soil+1,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( t_soil_p(nzb_soil:nzt_soil+1,nysg:nyng,nxlg:nxrg) )
+#else
+       ALLOCATE ( m_liq_eb_1(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( m_liq_eb_2(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( m_soil_1(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( m_soil_2(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( t_surface_1(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( t_surface_2(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( t_soil_1(nzb_soil:nzt_soil+1,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( t_soil_2(nzb_soil:nzt_soil+1,nysg:nyng,nxlg:nxrg) )
+#endif
+
+!
+!--    Allocate intermediate timestep arrays
+       ALLOCATE ( tm_liq_eb_m(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( tm_soil_m(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( tt_surface_m(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( tt_soil_m(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+
+!
+!--    Allocate 2D vegetation model arrays
+       ALLOCATE ( alpha_vg(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( c_liq(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( c_veg(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( f_sw_in(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( ghf_eb(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( gamma_w_sat(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( g_d(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( lai(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( l_vg(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( lambda_h_sat(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( lambda_surface_u(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( lambda_surface_s(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( m_fc(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( m_res(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( m_sat(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( m_wilt(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( n_vg(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( qsws_eb(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( qsws_soil_eb(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( qsws_liq_eb(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( qsws_veg_eb(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( r_a(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( r_canopy(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( r_soil(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( r_soil_min(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( r_s(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( r_canopy_min(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( shf_eb(nysg:nyng,nxlg:nxrg) )
+
+#if ! defined( __nopointer )
+!
+!-- Initial assignment of the pointers
+       t_soil    => t_soil_1;    t_soil_p    => t_soil_2
+       t_surface => t_surface_1; t_surface_p => t_surface_2
+       m_soil    => m_soil_1;    m_soil_p    => m_soil_2
+       m_liq_eb  => m_liq_eb_1;  m_liq_eb_p  => m_liq_eb_2
+#endif
+
+
+    END SUBROUTINE init_lsm_arrays
 
 !------------------------------------------------------------------------------!
@@ -432,145 +591,51 @@
 
 !
+!--    Calculate Exner function
+       exn       = ( surface_pressure / 1000.0_wp )**0.286_wp
+
+
+!
+!--    If no cloud physics is used, rho_surface has not been calculated before
+       IF ( .NOT. cloud_physics )  THEN
+          rho_surface = surface_pressure * 100.0_wp / ( r_d * pt_surface * exn )
+       ENDIF
+
+!
 !--    Calculate frequently used parameters
        rho_cp    = cp * rho_surface
        rd_d_rv   = r_d / r_v
        rho_lv    = rho_surface * l_v
-       drho_l_lv = 1.0 / (rho_l * l_v)
-
-!
-!--    Allocate skin and soil temperature / humidity
-#if defined( __nopointer )
-       ALLOCATE ( T_0(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( T_0_p(nysg:nyng,nxlg:nxrg) )
-#else
-       ALLOCATE ( T_0_1(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( T_0_2(nysg:nyng,nxlg:nxrg) )
-#endif
-
-       ALLOCATE ( tT_0_m(nysg:nyng,nxlg:nxrg) )
-
-#if defined( __nopointer )
-       ALLOCATE ( T_soil(0:soil_layers,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( T_soil_p(0:soil_layers,nysg:nyng,nxlg:nxrg) )
-#else
-       ALLOCATE ( T_soil_1(0:soil_layers,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( T_soil_2(0:soil_layers,nysg:nyng,nxlg:nxrg) )
-#endif
-
-       ALLOCATE ( tT_soil_m(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )
-
-#if defined( __nopointer )
-       ALLOCATE ( m_liq(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_liq_p(nysg:nyng,nxlg:nxrg) )
-#else
-       ALLOCATE ( m_liq_1(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_liq_2(nysg:nyng,nxlg:nxrg) )
-#endif
-
-       ALLOCATE ( tm_liq_m(nysg:nyng,nxlg:nxrg) )
-
-#if defined( __nopointer )
-       ALLOCATE ( m_soil(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_soil_p(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )
-#else
-       ALLOCATE ( m_soil_1(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_soil_2(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )
-#endif
-
-       ALLOCATE ( tm_soil_m(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )
-
-
-#if ! defined( __nopointer )
-!
-!--    Initial assignment of the pointers
-       T_soil => T_soil_1; T_soil_p => T_soil_2
-       T_0 => T_0_1; T_0_p => T_0_2
-       m_soil => m_soil_1; m_soil_p => m_soil_2
-       m_liq => m_liq_1; m_liq_p => m_liq_2
-#endif
-
-       T_0    = 0.0_wp
-       T_0_p  = 0.0_wp
-       tT_0_m = 0.0_wp
-
-       T_soil    = 0.0_wp
-       T_soil_p  = 0.0_wp
-       tT_soil_m = 0.0_wp
-
-       m_liq    = 0.0_wp
-       m_liq_p  = 0.0_wp
-       tm_liq_m = 0.0_wp
-
-       m_soil    = 0.0_wp
-       m_soil_p  = 0.0_wp
-       tm_soil_m = 0.0_wp
-
-!
-!--    Allocate 2D vegetation model arrays
-       ALLOCATE ( alpha_VG(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( c_liq(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( c_veg(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( f_SW_in(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( G(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( H(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( gamma_w_sat(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( gD(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( LAI(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( LE(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( LE_veg(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( LE_soil(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( LE_liq(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( l_VG(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( lambda_h_sat(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( lambda_skin_u(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( lambda_skin_s(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_fc(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_res(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_sat(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_wilt(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( n_VG(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_a(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_canopy(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_soil(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_soil_min(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_s(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_s_min(nysg:nyng,nxlg:nxrg) )
-
-!
-!--    Set initial and default values
-       c_liq   = 0.0_wp
-       c_veg   = 0.0_wp
-       f_SW_in = 0.05_wp
-       gD      = 0.0_wp
-       LAI     = 0.0_wp
-       lambda_skin_u = 10.0_wp
-       lambda_skin_s = 10.0_wp
-
-
-       G       = 0.0_wp
-       H       = rho_cp * shf
+       drho_l_lv = 1.0_wp / (rho_l * l_v)
+
+!
+!--    Set inital values for prognostic quantities
+       tt_surface_m = 0.0_wp
+       tt_soil_m    = 0.0_wp
+       tm_liq_eb_m  = 0.0_wp
+       c_liq        = 0.0_wp
+
+       ghf_eb = 0.0_wp
+       shf_eb = rho_cp * shf
 
        IF ( humidity )  THEN
-          LE = rho_l * l_v * qsws
+          qsws_eb = rho_l * l_v * qsws
        ELSE
-          LE = 0.0_wp
+          qsws_eb = 0.0_wp
        ENDIF
 
-       LE_veg  = 0.0_wp
-       LE_soil = LE
-       LE_liq  = 0.0_wp
+       qsws_liq_eb  = 0.0_wp
+       qsws_soil_eb = qsws_eb
+       qsws_veg_eb  = 0.0_wp
 
        r_a        = 50.0_wp
+       r_s        = 50.0_wp
        r_canopy   = 0.0_wp
        r_soil     = 0.0_wp
-       r_soil_min = 50.0_wp
-       r_s        = 110.0_wp
-       r_s_min    = min_canopy_resistance
 
 !
 !--    Allocate 3D soil model arrays
-       ALLOCATE ( root_fr(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( lambda_h(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( rhoC_total(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( root_fr(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( lambda_h(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( rho_c_total(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
 
        lambda_h = 0.0_wp
@@ -578,6 +643,6 @@
 !--    If required, allocate humidity-related variables for the soil model
        IF ( humidity )  THEN
-          ALLOCATE ( lambda_w(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( gamma_w(0:soil_layers-1,nysg:nyng,nxlg:nxrg) )   
+          ALLOCATE ( lambda_w(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( gamma_w(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )   
 
           lambda_w = 0.0_wp 
@@ -588,55 +653,121 @@
 !--    the center of the soil layers, whereas gradients/fluxes are defined
 !--    at the edges (_stag)
-       dz_soil_stag(0) = soil_level(0)
-
-       DO k = 1, soil_layers-1
-          dz_soil_stag(k) = soil_level(k) - soil_level(k-1)
+       dz_soil_stag(nzb_soil) = zs(nzb_soil)
+
+       DO k = nzb_soil+1, nzt_soil
+          dz_soil_stag(k) = zs(k) - zs(k-1)
        ENDDO
 
-       DO k = 0, soil_layers-2
+       DO k = nzb_soil, nzt_soil-1
           dz_soil(k) = 0.5 * (dz_soil_stag(k+1) + dz_soil_stag(k))
        ENDDO
-       dz_soil(soil_layers-1) = dz_soil_stag(soil_layers-1)
-
-       ddz_soil      = 1.0 / dz_soil
-       ddz_soil_stag = 1.0 / dz_soil_stag
-!
-!--    Initialize soil
-       IF ( soil_type .NE. 0 )  THEN   
-          alpha_VG    = soil_pars(0,soil_type)
-          l_VG        = soil_pars(1,soil_type)
-          n_VG        = soil_pars(2,soil_type)    
-          gamma_w_sat = soil_pars(3,soil_type) 
-          m_sat       = m_soil_pars(0,soil_type)
-          m_fc        = m_soil_pars(1,soil_type)   
-          m_wilt      = m_soil_pars(2,soil_type) 
-          m_res       = m_soil_pars(3,soil_type)
+       dz_soil(nzt_soil) = dz_soil_stag(nzt_soil)
+
+       ddz_soil      = 1.0_wp / dz_soil
+       ddz_soil_stag = 1.0_wp / dz_soil_stag
+
+!
+!--    Initialize standard soil types. It is possible to overwrite each
+!--    parameter by setting the respecticy NAMELIST variable to a 
+!--    value /= 9999999.9. 
+       IF ( soil_type /= 0 )  THEN  
+ 
+          IF ( alpha_vangenuchten == 9999999.9_wp )  THEN
+             alpha_vangenuchten = soil_pars(0,soil_type)
+          ENDIF
+
+          IF ( l_vangenuchten == 9999999.9_wp )  THEN
+             l_vangenuchten = soil_pars(1,soil_type)
+          ENDIF
+
+          IF ( n_vangenuchten == 9999999.9_wp )  THEN
+             n_vangenuchten = soil_pars(2,soil_type)            
+          ENDIF
+
+          IF ( hydraulic_conductivity == 9999999.9_wp )  THEN
+             hydraulic_conductivity = soil_pars(3,soil_type)            
+          ENDIF
+
+          IF ( saturation_moisture == 9999999.9_wp )  THEN
+             saturation_moisture = m_soil_pars(0,soil_type)           
+          ENDIF
+
+          IF ( field_capacity == 9999999.9_wp )  THEN
+             field_capacity = m_soil_pars(1,soil_type)           
+          ENDIF
+
+          IF ( wilting_point == 9999999.9_wp )  THEN
+             wilting_point = m_soil_pars(2,soil_type)            
+          ENDIF
+
+          IF ( residual_moisture == 9999999.9_wp )  THEN
+             residual_moisture = m_soil_pars(3,soil_type)       
+          ENDIF
+
+       ENDIF    
+
+       alpha_vg      = alpha_vangenuchten
+       l_vg          = l_vangenuchten
+       n_vg          = n_vangenuchten 
+       gamma_w_sat   = hydraulic_conductivity
+       m_sat         = saturation_moisture
+       m_fc          = field_capacity
+       m_wilt        = wilting_point
+       m_res         = residual_moisture
+       r_soil_min    = min_soil_resistance
+
+!
+!--    Initial run actions
+       IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+
+          t_soil    = 0.0_wp
+          m_liq_eb  = 0.0_wp
+          m_soil    = 0.0_wp
+
+!
+!--       Map user settings of T and q for each soil layer
+!--       (make sure that the soil moisture does not drop below the permanent
+!--       wilting point) -> problems with devision by zero)
+          DO k = nzb_soil, nzt_soil
+             t_soil(k,:,:)    = soil_temperature(k)
+             m_soil(k,:,:)    = MAX(soil_moisture(k),m_wilt(:,:))
+             soil_moisture(k) = MAX(soil_moisture(k),wilting_point)
+          ENDDO
+          t_soil(nzt_soil+1,:,:) = soil_temperature(nzt_soil+1)
+
+!
+!--       Calculate surface temperature
+          t_surface = pt_surface * exn
+
+!
+!--       Set artifical values for ts and us so that r_a has its initial value for 
+!--       the first time step
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
+                k = nzb_s_inner(j,i)
+
+!
+!--             Assure that r_a cannot be zero at model start
+                IF ( pt(k+1,j,i) == pt(k,j,i) )  pt(k+1,j,i) = pt(k+1,j,i)     &
+                                                 + 1.0E-10_wp
+
+                us(j,i) = 0.1_wp
+                ts(j,i) = (pt(k+1,j,i) - pt(k,j,i)) / r_a(j,i)
+                shf(j,i) = - us(j,i) * ts(j,i)
+             ENDDO
+          ENDDO
+
+!
+!--    Actions for restart runs
        ELSE
-          alpha_VG    = alpha_VanGenuchten
-          l_VG        = l_VanGenuchten
-          n_VG        = n_VanGenuchten 
-          gamma_w_sat = hydraulic_conductivity
-          m_sat       = saturation_moisture
-          m_fc        = field_capacity
-          m_wilt      = wilting_point
-          m_res       = residual_moisture
-       ENDIF    
-
-!
-!--    Map user settings of T and q for each soil layer
-!--    (make sure that the soil moisture does not drop below the permanent
-!--    wilting point) -> problems with devision by zero)
-       DO k = 0, soil_layers-1
-          T_soil(k,:,:)  = soil_temperature(k)
-          m_soil(k,:,:)  = MAX(soil_moisture(k),m_wilt(:,:))
-       ENDDO
-       T_soil(soil_layers,:,:) = soil_temperature(soil_layers)
-
-
-       exn = ( surface_pressure / 1000.0_wp )**0.286_wp
-       T_0  = pt_surface * exn
-
-       T_soil_p = T_soil
-       m_soil_p = m_soil
+
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
+                k = nzb_s_inner(j,i)                
+                t_surface(j,i) = pt(k,j,i) * exn
+             ENDDO
+          ENDDO
+
+       ENDIF
 
 !
@@ -645,30 +776,62 @@
                            lambda_h_water ** m_sat(:,:)
 
+
+
+
+       DO k = nzb_soil, nzt_soil
+          root_fr(k,:,:) = root_fraction(k)
+       ENDDO
+
+       IF ( veg_type /= 0 )  THEN
+          IF ( min_canopy_resistance == 9999999.9_wp )  THEN
+             min_canopy_resistance = veg_pars(0,veg_type)
+          ENDIF
+          IF ( leaf_area_index == 9999999.9_wp )  THEN
+             leaf_area_index = veg_pars(1,veg_type)         
+          ENDIF
+          IF ( vegetation_coverage == 9999999.9_wp )  THEN
+             vegetation_coverage = veg_pars(2,veg_type)     
+          ENDIF
+          IF ( canopy_resistance_coefficient == 9999999.9_wp )  THEN
+              canopy_resistance_coefficient= veg_pars(3,veg_type)     
+          ENDIF
+          IF ( lambda_surface_stable == 9999999.9_wp )  THEN
+             lambda_surface_stable = surface_pars(0,veg_type)         
+          ENDIF
+          IF ( lambda_surface_unstable == 9999999.9_wp )  THEN
+             lambda_surface_unstable = surface_pars(1,veg_type)        
+          ENDIF
+          IF ( f_shortwave_incoming == 9999999.9_wp )  THEN
+             f_shortwave_incoming = surface_pars(2,veg_type)        
+          ENDIF
+          IF ( z0_eb == 9999999.9_wp )  THEN
+             roughness_length = roughness_par(0,veg_type) 
+             z0_eb            = roughness_par(0,veg_type) 
+          ENDIF
+          IF ( z0h_eb == 9999999.9_wp )  THEN
+             z0h_eb = roughness_par(1,veg_type)
+          ENDIF
+          z0h_factor = z0h_eb / z0_eb
+
+          IF ( ANY( root_fraction == 9999999.9_wp ) )  THEN
+             DO k = nzb_soil, nzt_soil
+                root_fr(k,:,:) = root_distribution(k,veg_type)
+                root_fraction(k) = root_distribution(k,veg_type)
+             ENDDO
+          ENDIF
+
+       ENDIF
+
 !
 !--    Initialize vegetation
-       IF ( veg_type .NE. 0 )  THEN
-
-          r_s_min              = veg_pars(0,veg_type)
-          LAI                  = veg_pars(1,veg_type)
-          c_veg                = veg_pars(2,veg_type)
-          gD                   = veg_pars(3,veg_type)
-          lambda_skin_s        = skin_pars(0,veg_type)
-          lambda_skin_u        = skin_pars(1,veg_type)
-          f_SW_in              = skin_pars(2,veg_type)
-          z0                   = roughness_par(0,veg_type)
-          z0h                  = roughness_par(1,veg_type)
-
-
-          DO k = 0, soil_layers-1
-             root_fr(k,:,:) = root_distribution(k,veg_type)
-          ENDDO
-
-       ELSE
-
-          DO k = 0, soil_layers-1
-             root_fr(k,:,:) = root_fraction(k)
-          ENDDO
-
-       ENDIF
+       r_canopy_min         = min_canopy_resistance
+       lai                  = leaf_area_index
+       c_veg                = vegetation_coverage
+       g_d                  = canopy_resistance_coefficient
+       lambda_surface_s     = lambda_surface_stable
+       lambda_surface_u     = lambda_surface_unstable
+       f_sw_in              = f_shortwave_incoming
+       z0                   = z0_eb
+       z0h                  = z0h_eb
 
 !
@@ -676,25 +839,39 @@
        CALL user_init_land_surface
 
-!
-!--    Set artifical values for ts and us so that r_a has its initial value for 
-!--    the first time step
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             k = nzb_s_inner(j,i)
-!
-!--          Assure that r_a cannot be zero at model start
-             IF ( pt(k+1,j,i) == pt(k,j,i) )  pt(k+1,j,i) = pt(k+1,j,i) + 1.0E-10_wp
-
-             us(j,i) = 0.1_wp
-             ts(j,i) = (pt(k+1,j,i) - pt(k,j,i)) / r_a(j,i)
-             shf(j,i) = - us(j,i) * ts(j,i)
-          ENDDO
-       ENDDO
+
+       t_soil_p    = t_soil
+       m_soil_p    = m_soil
+       m_liq_eb_p  = m_liq_eb
+
+!--    Store initial profiles of t_soil and m_soil (assuming they are 
+!--    horizontally homogeneous on this PE)
+       hom(nzb_soil:nzt_soil,1,90,:)  = SPREAD( t_soil(nzb_soil:nzt_soil,      &
+                                                nysg,nxlg), 2,                 &
+                                                statistic_regions+1 )
+       hom(nzb_soil:nzt_soil,1,92,:)  = SPREAD( m_soil(nzb_soil:nzt_soil,      &
+                                                nysg,nxlg), 2,                 &
+                                                statistic_regions+1 )
 
 !
 !--    Calculate humidity at the surface
        IF ( humidity )  THEN
-          CALL calc_q0
+          CALL calc_q_surface
        ENDIF
+
+
+
+!
+!--    Add timeseries for land surface model
+       dots_label(dots_num+1) = "ghf_eb"
+       dots_label(dots_num+2) = "shf_eb"
+       dots_label(dots_num+3) = "qsws_eb"
+       dots_label(dots_num+4) = "qsws_liq_eb"
+       dots_label(dots_num+5) = "qsws_soil_eb"
+       dots_label(dots_num+6) = "qsws_veg_eb"
+       dots_unit(dots_num+1:dots_num+6) = "W/m2"
+
+       dots_soil = dots_num + 1
+       dots_num  = dots_num + 6
+
 
        RETURN
@@ -707,5 +884,11 @@
 ! Description:
 ! ------------
-!
+! Solver for the energy balance at the surface.
+!
+! Note: surface fluxes are calculated in the land surface model, but these are
+! not used in the atmospheric code. The fluxes are calculated afterwards in
+! prandtl_fluxes using the surface values of temperature and humidity as
+! provided by the land surface model. In this way, the fluxes in the land
+! surface model are not equal to the ones calculated in prandtl_fluxes
 !------------------------------------------------------------------------------!
     SUBROUTINE lsm_energy_balance
@@ -730,11 +913,12 @@
                    coef_1,      & !: coef. for prognostic equation
                    coef_2,      & !: coef. for prognostic equation
-                   f_LE,        & !: factor for LE
-                   f_LE_veg,    & !: factor for LE_veg
-                   f_LE_soil,   & !: factor for LE_soil
-                   f_LE_liq,    & !: factor for LE_liq
-                   f_H,         & !: factor for H
-                   lambda_skin, & !: Current value of lambda_skin
-                   m_liq_max      !: maxmimum value of the liquid water reservoir
+                   f_qsws,      & !: factor for qsws_eb
+                   f_qsws_veg,  & !: factor for qsws_veg_eb
+                   f_qsws_soil, & !: factor for qsws_soil_eb
+                   f_qsws_liq,  & !: factor for qsws_liq_eb
+                   f_shf,       & !: factor for shf_eb
+                   lambda_surface, & !: Current value of lambda_surface
+                   m_liq_eb_max   !: maxmimum value of the liq. water reservoir
+
 
 !
@@ -748,9 +932,9 @@
 
 !
-!--          Set lambda_skin according to stratification
+!--          Set lambda_surface according to stratification
              IF ( rif(j,i) >= 0.0_wp )  THEN
-                lambda_skin = lambda_skin_s(j,i)
+                lambda_surface = lambda_surface_s(j,i)
              ELSE
-                lambda_skin = lambda_skin_u(j,i)
+                lambda_surface = lambda_surface_u(j,i)
              ENDIF
 
@@ -760,5 +944,6 @@
 !--          time step is used here. Note that this formulation is the
 !--          equivalent to the ECMWF formulation using drag coefficients
-             r_a(j,i) = (pt(k+1,j,i) - pt(k,j,i)) / (ts(j,i) * us(j,i) + 1.0E-20)
+             r_a(j,i) = (pt(k+1,j,i) - pt(k,j,i)) / (ts(j,i) * us(j,i) +       &
+                         1.0E-20_wp)
 
 !
@@ -766,17 +951,27 @@
 !--          f1-f3 here are defined as 1/f1-f3 as in ECMWF documentation
  
-!--          f1: correction for incoming shortwave radiation
-             f1 = MIN(1.0_wp, ( 0.004_wp * SW_in(j,i) + 0.05_wp ) /     &
-                              (0.81_wp * (0.004_wp * SW_in(j,i) + 1.0_wp) ) )
-
-!
-!--          f2: correction for soil moisture f2=0 for very dry soil
+!--          f1: correction for incoming shortwave radiation (stomata close at 
+!--          night)
+             IF ( irad_scheme /= 0 )  THEN
+                f1 = MIN(1.0_wp, ( 0.004_wp * rad_sw_in(j,i) + 0.05_wp ) /     &
+                              (0.81_wp * (0.004_wp * rad_sw_in(j,i) + 1.0_wp) ))
+             ELSE
+                f1 = 1.0_wp
+             ENDIF
+
+!
+!--          f2: correction for soil moisture availability to plants (the 
+!--          integrated soil moisture must thus be considered here)
+!--          f2 = 0 for very dry soils
              m_total = 0.0_wp
-             DO ks = 0, soil_layers-1
-                 m_total = m_total + root_fr(ks,j,i) * m_soil(ks,j,i)
+             DO ks = nzb_soil, nzt_soil
+                 m_total = m_total + root_fr(ks,j,i)                           &
+                           * MAX(m_soil(ks,j,i),m_wilt(j,i))
              ENDDO 
 
-             IF (  m_total .GT. m_wilt(j,i) .AND. m_total .LE. m_fc(j,i) )  THEN
+             IF ( m_total .GT. m_wilt(j,i) .AND. m_total .LT. m_fc(j,i) )  THEN
                 f2 = ( m_total - m_wilt(j,i) ) / (m_fc(j,i) - m_wilt(j,i) )
+             ELSEIF ( m_total .GE. m_fc(j,i) )  THEN
+                f2 = 1.0_wp
              ELSE
                 f2 = 1.0E-20_wp
@@ -785,15 +980,14 @@
 !
 !--          Calculate water vapour pressure at saturation 
-!--          (T_0 should be replaced by liquid water temp?!)
-             e_s = 0.01 * 610.78_wp * EXP( 17.269_wp * ( T_0(j,i) - 273.16_wp )&
-                                           / ( T_0(j,i) - 35.86_wp ) )
+             e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * ( t_surface(j,i)     &
+                           - 273.16_wp ) / ( t_surface(j,i) - 35.86_wp ) )
 
 !
 !--          f3: correction for vapour pressure deficit
-             IF ( gD(j,i) .NE. 0.0_wp )  THEN
+             IF ( g_d(j,i) /= 0.0_wp )  THEN
 !
 !--             Calculate vapour pressure
-                e  = q_p(k+1,j,i) * surface_pressure / 0.622
-                f3 = EXP ( -gD(j,i) * (e_s - e) )
+                e  = q_p(k+1,j,i) * surface_pressure / 0.622_wp
+                f3 = EXP ( -g_d(j,i) * (e_s - e) )
              ELSE
                 f3 = 1.0_wp
@@ -801,14 +995,23 @@
 
 !
+!--          Calculate canopy resistance. In case that c_veg is 0 (bare soils),
+!--          this calculation is obsolete, as r_canopy is not used below.
 !--          To do: check for very dry soil -> r_canopy goes to infinity
-             r_canopy(j,i)  = r_s_min(j,i) / (LAI(j,i) * f1 * f2 * f3 + 1.0E-20)
-
-!
-!--          Third step: calculate bare soil resistance r_soil
-             m_min = c_veg(j,i) * m_wilt(j,i) + (1.0_wp - c_veg(j,i)) *        &
-                     m_res(j,i)
-
-             f2 = ( m_soil(0,j,i) - m_min ) / ( m_fc(j,i) - m_min )
+             r_canopy(j,i) = r_canopy_min(j,i) / (lai(j,i) * f1 * f2 * f3      &
+                                             + 1.0E-20_wp)
+
+!
+!--          Third step: calculate bare soil resistance r_soil. The Clapp & 
+!--          Hornberger parametrization does not consider c_veg.
+             IF ( soil_type /= 7 )  THEN
+                m_min = c_veg(j,i) * m_wilt(j,i) + (1.0_wp - c_veg(j,i)) *     &
+                        m_res(j,i)
+             ELSE
+                m_min = m_wilt(j,i)
+             ENDIF
+
+             f2 = ( m_soil(nzb_soil,j,i) - m_min ) / ( m_fc(j,i) - m_min )
              f2 = MAX(f2,1.0E-20_wp)
+             f2 = MIN(f2,1.0_wp)
 
              r_soil(j,i) = r_soil_min(j,i) / f2
